﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Web;
using System.Net.Http;
using System.Web.Http;
using System.Web.Http.OData;
using Syncfusion.JavaScript.Models;
using System.Web.Http.OData.Query;
using Sample.Models;
using MVCSampleBrowser.Models;

namespace Sample.Models
{
    public class ValuesController : ApiController
    {
        NorthWndDataContext db = new NorthWndDataContext();
        // GET api/<controller>
        //public object Get(ODataQueryOptions opts)
        //{
        //     var queryString = HttpContext.Current.Request.QueryString;
        //    int skip = Convert.ToInt32(queryString["$skip"]);
        //    int take = Convert.ToInt32(queryString["$top"]);
        //    var datasource = OrderRepository.GetAllRecords();
        //     //var results = datasource.AsQueryable();
        //     var data = datasource.Skip(skip).Take(take).ToList();
        //     var count = 0;
        //    if (opts.Filter != null)
        //    {
        //       // results = opts.Filter.ApplyTo(results, new ODataQuerySettings()).Cast<Order>();
        //        count = datasource.Count();
        //        //return new object(datasource, null, count);
        //    }
            
        //    return new { Items = data.Skip(skip).Take(take), Count = data.Count() };
        //}
        public PageResult<EditableOrder> Get(ODataQueryOptions opts)
        {
            var data = OrderRepository.GetAllRecords().ToList();
            var count = 0;
            var result = data.AsQueryable();
            if (opts.InlineCount != null)
                count = result.Count();

            if (opts.Filter != null)
            {
                result = opts.Filter.ApplyTo(result, new ODataQuerySettings()).Cast<EditableOrder>();

                count = result.Count();
                return new PageResult<EditableOrder>(result, null, count);
            }
            else
                return new PageResult<EditableOrder>(opts.ApplyTo(result.AsQueryable()) as IEnumerable<EditableOrder>, null, count);
        }

        // GET api/<controller>/5
        public string Get(int id)
        {
            return "value";
        }

        // POST api/<controller>
        public void Post([FromBody]string value)
        {
        }

        // PUT api/<controller>/5
        public void Put(int id, [FromBody]string value)
        {
        }

        // DELETE api/<controller>/5
        public void Delete(int id)
        {
        }
    }
}